

#property indicator_separate_window
#property indicator_minimum 0.0
#property indicator_maximum 0.1
#property indicator_buffers 1
#property indicator_color1 Black

extern color ExtColor = Olive;
string gs_80 = "Info";
string gsa_unused_88[1024];
double gda_92[1024];
int g_count_96 = 0;
double gda_100[1024][10];
int gia_104[1024];
string gsa_108[1024][2];
int g_count_112 = -1;
string gsa_116[12] = {"Order", "Time", "Type", "Size", "Symbol", "Price", "S/L", "T/P", "Price", "Commission", "Swap", "Profit"};
int gia_120[12] = {10, 80, 200, 250, 300, 380, 450, 520, 580, 650, 730, 780};
int g_y_124 = 14;
double g_ibuf_128[];

void init() {
   IndicatorShortName(gs_80);
   SetIndexBuffer(0, g_ibuf_128);
   SetIndexStyle(0, DRAW_NONE);
   IndicatorDigits(0);
   SetIndexEmptyValue(0, 0.0);
}

void deinit() {
   int li_0 = WindowFind(gs_80);
   if (li_0 > 0) ObjectsDeleteAll(li_0);
}

void start() {
   string l_name_8;
   int l_count_24;
   int li_40;
   int l_y_44;
   int l_digits_48;
   double ld_52;
   string l_text_60;
   string ls_0 = Symbol();
   RefreshRates();
   int li_28 = WindowFind(gs_80);
   if (li_28 > 0) ObjectsDeleteAll(li_28);
   if (li_28 >= 0) {
      g_count_112 = -1;
      if (g_count_112 < 0) {
         for (int l_index_20 = 0; l_index_20 < 12; l_index_20++) {
            l_name_8 = "Head_" + l_index_20;
            if (ObjectCreate(l_name_8, OBJ_LABEL, li_28, 0, 0)) {
               ObjectSet(l_name_8, OBJPROP_XDISTANCE, gia_120[l_index_20]+21);
               ObjectSet(l_name_8, OBJPROP_YDISTANCE, g_y_124-13);
               ObjectSetText(l_name_8, gsa_116[l_index_20], 9, "Arial", ExtColor);
            }
         }
         g_count_112 = 0;
      }
      ArrayInitialize(gda_100, 0.0);
      for (int l_index_32 = 0; l_index_32 < 1024; l_index_32++) for (int l_count_36 = 0; l_count_36 < 10; l_count_36++) gda_100[l_index_32][l_count_36] = 0.0;
      li_40 = Analyze();
      if (li_40 > 0) {
         l_count_24 = 0;
         for (int l_index_16 = 0; l_index_16 < li_40; l_index_16++) {
            if (gda_100[l_index_16][9] > 0.0) {
               l_count_24++;
               if (l_count_24 > g_count_112) {
                  l_y_44 = g_y_124 * (l_count_24 + 1) + 1;
                  for (l_index_20 = 0; l_index_20 < 12; l_index_20++) {
                     l_name_8 = "Line_" + l_count_24 + "_" + l_index_20;
                     if (ObjectCreate(l_name_8, OBJ_LABEL, li_28, 0, 0)) {
                        ObjectSet(l_name_8, OBJPROP_XDISTANCE, gia_120[l_index_20]+21);
                        ObjectSet(l_name_8, OBJPROP_YDISTANCE, l_y_44-13);
                     }
                  }
                  g_count_112++;
               }
               l_digits_48 = MarketInfo(gsa_108[l_index_16][1], MODE_DIGITS);
               l_name_8 = "Line_" + l_count_24 + "_0";
               ObjectSetText(l_name_8, DoubleToStr(gda_100[l_index_16][0], 0), 9, "Arial", ExtColor);
               l_name_8 = "Line_" + l_count_24 + "_1";
               ObjectSetText(l_name_8, TimeToStr(gia_104[l_index_16], TIME_DATE|TIME_MINUTES), 9, "Arial", ExtColor);
               l_name_8 = "Line_" + l_count_24 + "_2";
               ObjectSetText(l_name_8, gsa_108[l_index_16][0], 9, "Arial", ExtColor);
               l_name_8 = "Line_" + l_count_24 + "_3";
               ObjectSetText(l_name_8, DoubleToStr(gda_100[l_index_16][1], 2), 9, "Arial", ExtColor);
               l_name_8 = "Line_" + l_count_24 + "_4";
               ObjectSetText(l_name_8, gsa_108[l_index_16][1], 9, "Arial", ExtColor);
               l_name_8 = "Line_" + l_count_24 + "_5";
               ObjectSetText(l_name_8, DoubleToStr(gda_100[l_index_16][2], l_digits_48), 9, "Arial", ExtColor);
               l_name_8 = "Line_" + l_count_24 + "_6";
               ObjectSetText(l_name_8, DoubleToStr(gda_100[l_index_16][3], l_digits_48), 9, "Arial", ExtColor);
               l_name_8 = "Line_" + l_count_24 + "_7";
               ObjectSetText(l_name_8, DoubleToStr(gda_100[l_index_16][4], l_digits_48), 9, "Arial", ExtColor);
               l_name_8 = "Line_" + l_count_24 + "_8";
               ObjectSetText(l_name_8, DoubleToStr(gda_100[l_index_16][5], l_digits_48), 9, "Arial", ExtColor);
               l_name_8 = "Line_" + l_count_24 + "_9";
               ObjectSetText(l_name_8, DoubleToStr(gda_100[l_index_16][6], 2), 9, "Arial", ExtColor);
               l_name_8 = "Line_" + l_count_24 + "_10";
               ObjectSetText(l_name_8, DoubleToStr(gda_100[l_index_16][7], 2), 9, "Arial", ExtColor);
               l_name_8 = "Line_" + l_count_24 + "_11";
               ObjectSetText(l_name_8, DoubleToStr(gda_100[l_index_16][8], 2), 9, "Arial", ExtColor);
            }
         }
      }
      g_ibuf_128[Bars - 1] = -1;
      l_name_8 = "Line_" + ((l_count_24 + 1)) + "_0";
      ld_52 = 0.0;
      for (l_index_16 = 0; l_index_16 < l_count_24; l_index_16++) ld_52 += gda_100[l_index_16][8] + gda_100[l_index_16][6] + gda_100[l_index_16][7];
      l_count_24++;
      if (ObjectCreate(l_name_8, OBJ_LABEL, li_28, 0, 0)) {
         g_count_112++;
         l_text_60 = "Balance: " + DoubleToStr(AccountBalance(), 2) + " Equity: " + DoubleToStr(AccountBalance() + ld_52, 2) + " Margin: " + DoubleToStr(AccountMargin(), 2) + " Free: " + DoubleToStr(AccountFreeMargin(), 2);
         ObjectSet(l_name_8, OBJPROP_XDISTANCE, gia_120[0]+21);
         ObjectSet(l_name_8, OBJPROP_YDISTANCE, g_y_124 * (l_count_24 + 1)-13);
         ObjectSetText(l_name_8, l_text_60, 9, "Arial", Red);
      }
      l_name_8 = "Line_" + l_count_24 + "_11";
      if (ObjectCreate(l_name_8, OBJ_LABEL, li_28, 0, 0)) {
         ObjectSet(l_name_8, OBJPROP_XDISTANCE, gia_120[11]+21);
         ObjectSet(l_name_8, OBJPROP_YDISTANCE, g_y_124 * (l_count_24 + 1)-13);
         ObjectSetText(l_name_8, DoubleToStr(ld_52, 2), 9, "Arial", Red);
      }

   }
}

int Analyze() {
   double ld_0;
   int li_12;
   int l_cmd_16;
   string ls_36;
   string ls_unused_44;
   double l_price_52;
   double l_ticksize_68;
   double l_tickvalue_76;
   double l_bid_92;
   double l_ask_100;
   double l_bid_108;
   double l_ask_116;
   int l_count_20 = OrdersTotal();
   int li_unused_24 = 0;
   int li_unused_28 = 0;
   int li_unused_32 = 0;
   g_count_96 = 0;
   for (int l_pos_8 = 0; l_pos_8 < l_count_20; l_pos_8++) {
      if (OrderSelect(l_pos_8, SELECT_BY_POS)) {
         l_cmd_16 = OrderType();
         if (l_cmd_16 != OP_BUY && l_cmd_16 != OP_SELL) continue;
         li_12 = SymbolsIndex(OrderTicket());
         if (li_12 < 0 || li_12 >= 1024) continue;
         gda_100[li_12][1] += OrderLots();
         gda_100[li_12][2] += OrderOpenPrice();
         ls_36 = StringSetChar(ls_36, 0, 0);
         ls_36 = StringConcatenate(OrderSymbol(), "#I");
         l_bid_92 = MarketInfo(ls_36, MODE_BID);
         l_ask_100 = MarketInfo(ls_36, MODE_ASK);
         l_bid_108 = MarketInfo(OrderSymbol(), MODE_BID);
         l_ask_116 = MarketInfo(OrderSymbol(), MODE_ASK);
         if (l_cmd_16 == OP_BUY) {
            if (l_bid_92 != 0.0) gda_100[li_12][5] += l_bid_92;
            else gda_100[li_12][5] += l_bid_108;
         } else {
            if (l_ask_100 != 0.0) gda_100[li_12][5] += l_ask_100;
            else gda_100[li_12][5] += l_ask_116;
         }
         gda_100[li_12][9]++;
         if (l_cmd_16 == OP_BUY) {
            if (l_bid_92 == 0.0) l_price_52 = l_bid_108;
            else l_price_52 = l_bid_92;
         } else {
            if (l_ask_100 == 0.0) l_price_52 = l_ask_116;
            else l_price_52 = l_ask_100;
         }
         l_ticksize_68 = MarketInfo(ls_36, MODE_TICKSIZE);
         l_tickvalue_76 = MarketInfo(ls_36, MODE_TICKVALUE);
         if (l_ticksize_68 == 0.0) l_ticksize_68 = MarketInfo(OrderSymbol(), MODE_TICKSIZE);
         if (l_tickvalue_76 == 0.0) l_tickvalue_76 = MarketInfo(OrderSymbol(), MODE_TICKVALUE);
         if (l_cmd_16 == OP_BUY) ld_0 = (l_price_52 - gda_100[li_12][2]) / l_ticksize_68 * l_tickvalue_76 * OrderLots() + OrderCommission() + OrderSwap();
         else ld_0 = (gda_100[li_12][2] - l_price_52) / l_ticksize_68 * l_tickvalue_76 * OrderLots() + OrderCommission() + OrderSwap();
         if (OrderClosePrice() - gda_100[li_12][2] == 0.0) ld_0 = OrderProfit();
         else ld_0 = (l_price_52 - gda_100[li_12][2]) * OrderProfit() / (OrderClosePrice() - gda_100[li_12][2]);
         gda_100[li_12][8] += ld_0;
         gda_100[li_12][0] = OrderTicket();
         gda_100[li_12][6] = OrderCommission();
         gda_100[li_12][7] = OrderSwap();
         gda_100[li_12][3] = OrderStopLoss();
         gda_100[li_12][4] = OrderTakeProfit();
         gia_104[li_12] = OrderOpenTime();
         if (OrderType() == OP_BUY) gsa_108[li_12][0] = "Buy";
         if (OrderType() == OP_SELL) gsa_108[li_12][0] = "Sell";
         gsa_108[li_12][1] = OrderSymbol();
      }
   }
   l_count_20 = 0;
   for (l_pos_8 = 0; l_pos_8 < g_count_96; l_pos_8++)
      if (gda_100[l_pos_8][9] > 0.0) l_count_20++;
   return (l_count_20);
}

int SymbolsIndex(int ai_0) {
   int li_unused_4 = 0;
   for (int l_index_8 = 0; l_index_8 < g_count_96; l_index_8++) {
      if (ai_0 == gda_92[l_index_8]) {
         li_unused_4 = 1;
         break;
      }
   }
   if (g_count_96 >= 1024) return (-1);
   l_index_8 = g_count_96;
   g_count_96++;
   gda_92[l_index_8] = ai_0;
   gda_100[l_index_8][0] = 0;
   gda_100[l_index_8][1] = 0;
   gda_100[l_index_8][2] = 0;
   gda_100[l_index_8][3] = 0;
   gda_100[l_index_8][4] = 0;
   gda_100[l_index_8][5] = 0;
   gda_100[l_index_8][6] = 0;
   gda_100[l_index_8][7] = 0;
   gda_100[l_index_8][8] = 0;
   gia_104[l_index_8] = 0;
   gsa_108[l_index_8][0] = 0;
   gsa_108[l_index_8][1] = 0;
   return (l_index_8);
}